using System;
using System.Collections.Generic;
using System.Text;
using OpenNETCF.Desktop.Communication;

namespace LCDAdapt
{
    class rapi
    {
        private RAPI rapiObj = null;
        private CERegistryKey DeviceReg;

        public rapi()
        {
            rapiObj = new RAPI();
         

            
        }

        ~rapi()
        {
            if (rapiObj.Connected)
            {
                try
                {
                    rapiObj.Disconnect();
                }
                catch
                {
                    throw new Exception("Unable to disconnect from device");
                }
            }
        }

        public RAPI Rapi
        {
            get
            {
                return rapiObj;
            }
        }

        public bool OpenRegKey(CERegistryKey MainKey,string SubKey)
        {
            if (rapiObj.DevicePresent)
            {
                if (!rapiObj.Connected)
                {
                    rapiObj.Connect();
                    if (!rapiObj.Connected)
                        return false;
                }
                try
                {
                    DeviceReg = MainKey;
                    DeviceReg = DeviceReg.OpenSubKey(SubKey, true);
                }
                catch
                {
                    throw new Exception("Failed to open reg key" + SubKey);
                }
                if (DeviceReg!=null)
                    return true;
            }
            return false;
        }
        public void CloseRegKey()
        {
            DeviceReg.Close();
        }
        public bool SetRegKey(string ValueName,object Data)
        {
            if (rapiObj.Connected)
            {
                try
                {
                    DeviceReg.SetValue(ValueName, Data);
                }
                catch
                {
                    throw new Exception("Unable to set registry value" + ValueName);
                }
                return true;
            }
            return false;
        }
        public UInt32 GetRegKeyValue(string ValueName)
        {
            if (rapiObj.Connected)
            {
                try
                {
                    return (UInt32)DeviceReg.GetValue(ValueName);
                }
                catch
                {
                    return 0XFFFFFFFF;
                }
            }
            return 0XFFFFFFFF;
        }
        public UInt32 GetRegKeyValue(string ValueName,out string ValueData)
        {
            ValueData = "";
            if (rapiObj.Connected)
            {
                try
                {
                    ValueData = (DeviceReg.GetValue(ValueName)).ToString();
                    return 0;
                }
                catch
                {
                    return 0XFFFFFFFF;
                }
            }
            return 0XFFFFFFFF;
        }
        public bool DeleteRegValue(string ValueName)
        {
            if (rapiObj.Connected)
            {
                try
                {
                    DeviceReg.DeleteValue(ValueName);
                }
                catch
                {
                    
                    throw new Exception("Unable to delete registry value " + ValueName + "\n");
                }
                return true;
            }
            return false;
        }

        public void ResetCMX300()
        {
            rapiObj.CreateProcess("\\Windows\\SetPowerState.exe","reboot");
        }
        public void ResetCMT35()
        {
            rapiObj.CreateProcess("\\Windows\\do.exe", "reboot");
        }
    }
}
